> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/aave-v3/umbrellaunstake.md).

# UmbrellaUnstake

### Description

UmbrellaUnstake - Unstake aTokens/underlying or GHO tokens using Umbrella Stake Token

> **Notes**
>
> This action will always unwrap waTokens to aTokens/underlying after unstaking. Passing zero as amount will start cooldown period.

### Action ID

`0x5ea3fadd`

### SDK Action

Following actions will map to UmbrellaUnstake contract:

```ts
const finalizeUnstakeAction = new sdk.actions.umbrella.UmbrellaFinalizeUnstakeAction(
    stkToken,
    to.address,
    amount,
    useATokens,
    minSharesOut
);
const startUnstakeAction = new sdk.actions.umbrella.UmbrellaStartUnstakeAction(
    stkToken
);

```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param stkToken The umbrella stake token.
    /// @param to The address to which the aToken/underlying or GHO will be transferred
    /// @param stkAmount The amount of stkToken shares to burn (max.uint to redeem whole balance, 0 to start cooldown period)
    /// @param useATokens Whether to unwrap waTokens to aTokens or underlying (e.g. aUSDC or USDC).
    /// @param minAmountOut The minimum amount of aToken/underlying or GHO to be received
    struct Params {
        address stkToken;
        address to;
        uint256 stkAmount;
        bool useATokens;
        uint256 minAmountOut;
    }
```

### Return Value

```solidity
return bytes32(redeemedAmount);
```

### Events and Logs

```solidity
emit ActionEvent("UmbrellaUnstake", logData);
logger.logActionDirectEvent("UmbrellaUnstake", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/aave-v3/umbrellaunstake.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
